import axios from 'axios'

// 创建axios实例
const service = axios.create({
  baseURL: import.meta.env.VITE_APP_BASE_URL, // 基础URL
  timeout: 15000 // 请求超时时间
})

// 请求拦截器
service.interceptors.request.use(
  config => {
    // 在发送请求之前做些什么
    const token = localStorage.getItem('access_token')
    // const token = "eyJhbGciOiJIUzUxMiJ9.eyJzdWIiOiJhZG1pbiIsImxvZ2luX3VzZXJfa2V5IjoiMGU0YWI2NDQtYTEwNy00MWM4LTg2YjEtYzlmMjEyYWQ0ODcxIn0.tYNWXxIWTEF2Kj6LG1JppNU6DzBLuLqEu64ZfxpqMvhrcBgOkDebgW-_5Uf8R4bWZy3OSoaOh5J1A0bbAUJxsA";
    if (token) {
      // 让每个请求携带自定义token
      config.headers['Authorization'] = 'Bearer ' + token
    }
    return config
  },
  error => {
    // 对请求错误做些什么
    console.log(error)
    return Promise.reject(error)
  }
)

// 响应拦截器
service.interceptors.response.use(
  response => {
    // 对响应数据做点什么
    const res = response.data
    
    // 如果自定义代码不是200，则判断为错误
    if (res.code === 200) {
      return res
    } else {
      // 统一处理错误
      console.log('请求错误:', res.message)
      return Promise.reject(new Error(res.message || 'Error'))
    }
  },
  error => {
    // 对响应错误做点什么
    console.log('err' + error)
    if (error.response && error.response.status) {
      switch (error.response.status) {
        // 401: 未登录
        case 401:
          console.log('未登录或登录过期')
          // 清除本地token并跳转至登录页
          localStorage.removeItem('access_token')
          // window.location.href = '/login'
          break
        // 403: token过期
        case 403:
          console.log('登录过期或无权限')
          // 清除token并跳转至登录页
          localStorage.removeItem('access_token')
          // window.location.href = '/login'
          break
        // 500: 服务器错误
        case 500:
          console.log('服务器内部错误')
          break
        default:
          console.log('其他错误')
      }
      return Promise.reject(error)
    }
  }
)

export default service